﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.utils.setInterval;

	public class Liner extends Sprite
	{
		public var balls:Array
		public function Liner()
		{
			balls = new Array();
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			setInterval(buildScreen,1);
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			balls = new Array();
		}
		private function clickHandler(e:MouseEvent):void
		{
			var pt:Point = new Point(e.stageX,e.stageY);
			var obj:Object = {"posx":(this.globalToLocal(pt).x)-1000,"posy":this.globalToLocal(pt).y,"angle":5,"rayon":mouseX,"centerY":this.globalToLocal(pt).y, "centerX":this.globalToLocal(pt).x};
			balls.push(obj);
			balls.sortOn(["angle"],[Array.NUMERIC]);
		}
		
		private function buildScreen():void
		{
			this.graphics.clear();
			for(var i:Number = 0;i<balls.length;i++){
				graphics.beginFill(0x000000,0);
				graphics.drawCircle(balls[i].posx,balls[i].posy,10);
				
				graphics.endFill();
				graphics.lineStyle((balls[i].posx)/10,0xffffff,0.9);
				//draw the lines
				if(i>0){
					graphics.moveTo(balls[i-1].posx,balls[i-1].posy);
					graphics.lineTo(balls[i].posy,balls[i].posx);
				}
				graphics.lineStyle();
				//set the new position
				balls[i].posx = balls[i].centerY + Math.sin(balls[i].angle*Math.PI/180)*balls[i].rayon;
				balls[i].posy = balls[i].centerX + Math.cos(balls[i].angle*Math.PI/180)*balls[i].rayon;
				balls[i].angle++;
			}
		}
	}
}